<script setup lang="ts">
import { onBeforeMount, onMounted } from "vue";
import { useCookies } from "vue3-cookies";
import { useAuthStore } from "@/stores/users";
import { useRoute, useRouter } from "vue-router";
import { OpenAPI } from "@/client";
import { environment } from "@/environment";
import axios from "axios";
import { useNameStore } from "@/stores/names";
import AppHeader from "@/components/AppHeader.vue";
import AppFooter from "@/components/AppFooter.vue";
import { useBucketStore } from "@/stores/buckets";
import { useS3KeyStore } from "@/stores/s3keys";

const { cookies } = useCookies();
const router = useRouter();
const route = useRoute();
const userRepository = useAuthStore();
const nameRepository = useNameStore();
const bucketRepository = useBucketStore();
const s3KeyRepository = useS3KeyStore();

onBeforeMount(() => {
  OpenAPI.BASE = environment.S3PROXY_API_BASE_URL;
  axios.interceptors.response.use(
    (res) => res,
    (err) => {
      if (
        (err.response.status === 400 || err.response.status === 403) &&
        err.response.data.detail?.includes("JWT")
      ) {
        userRepository.logout();
        cookies.remove("bearer");
        router.push({
          name: "login",
          query: {
            login_error:
              err.response.status === 400 ? "token_invalid" : "token_expired",
            return_path:
              route.name != "login" ? encodeURI(route.path) : undefined,
          },
        });
      }
      return Promise.reject(err);
    },
  );
  userRepository.setToken(cookies.get("bearer"));
  router.beforeEach(async (to) => {
    // make sure the user is authenticated
    if (
      !userRepository.authenticated &&
      // ❗️ Avoid an infinite redirect
      to.name !== "login"
    ) {
      // redirect the user to the login page and preserve query params for login error message
      return {
        name: "login",
        query: { ...to.query, return_path: encodeURI(to.path) },
      };
    } else if (to.name !== "login" && to.query.return_path) {
      // return to original path after login
      return { path: decodeURI(to.query.return_path as string) };
    }
  });
  nameRepository.loadNameMapping();
});

onMounted(() => {
  if (userRepository.authenticated) {
    bucketRepository.fetchOwnBuckets();
    s3KeyRepository.fetchS3Keys();
    bucketRepository.fetchOwnPermissions();
  }
});
</script>

<template>
  <AppHeader />
  <div class="container-xxl mt-4 flex-grow-1 py-2">
    <router-view></router-view>
  </div>
  <AppFooter />
</template>

<style scoped></style>
